/* JDxpc -- DXPC in pure Java
 *
 *  Copyright (C) 2000 ymnk, JCraft, Inc.
 *
 *  Many thanks to 
 *    Brian Pane<brianp@cnet.com> and
 *    Zachary Vonler<lightborn@mail.utexas.edu>.
 *  JDxpc has been based on their awesome works, dxpc.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package com.jcraft.jdxpc;

abstract class Channel extends Thread{
  protected int id;
  void setId(int id){this.id=id;}
  int getId(){ return id; }

  Proxy proxy=null;
  void setProxy(Proxy proxy){this.proxy=proxy;}

  boolean bigEndian=false;
  void setBigEndian(boolean foo){bigEndian=foo;}

  abstract void setSocket(java.net.Socket s);

  abstract public void run();
  abstract void close();
  abstract void doRead(ReadBuffer sReadBuffer, EncodeBuffer eBuffer)/* throws java.io.IOException*/;
  abstract void doWrite(byte[] buff, int start, int length);
}
